# For Continuous Deployment Using Jenkins with Gradle + Containerization with Docker

## Preparing Your Project 

### Configuring a finalJar Build Task with Gradle
We'll need to add another build task to build our applications with all of its dependencies packaged into the jar.

We can add a task like this:
```java
task finalJar(type: Jar) {
    manifest {
        attributes 'Main-Class': '[main-class]'
    }

    from sourceSets.main.output

    dependsOn configurations.runtimeClasspath
    from {
        configurations.runtimeClasspath.findAll { it.name.endsWith('jar') }.collect { zipTree(it) }
    }
    exclude 'META-INF/*.RSA', 'META-INF/*.SF','META-INF/*.DSA'
}
```

## Setting Up Your VM and Configuring Jenkins
1. Create an instance of a Linux Virtual Machine with the ubuntu 18.04 OS and the Standard B1s size. Make sure the VM allows traffic via SSH on port 22 for your IP, as well port 8080 for HTTP traffic. You will also want the port you are deploying your application on publicly accessible. Allow authorization with a key pair, generating a new one if you don't have one already. Save this pem file in a location you can easily remember and reference. We'll also need to allow traffic from the IP of this VM in our DB firewall.

2. Connect to your VM using ssh. You will need to provide the path to the pem file downloaded in part 1.

   > ssh -i [pem file] azureuser@[public ip]

3. Clone this repository onto your VM to access the start up script

   > git clone https://gitlab.com/carolynrehm/devops-scripts.git

5. Navigate into the project folder and execute install script. Select Java 8 when prompted.

   > cd devops-scripts

   > sh install.sh

6. Jenkins is ready for you to get started! Use the `cat` command to print the contents of the initialAdminPassword, install the suggested plugins, and set up an admin user.

7. See [jenkinsfile-examples](./jenkinsfile-deployment-example) for an example pipeline scripts for your desired jobs. Configure a pipeline script by selecting "New Item" on the left side of the landing page, create a name for your job, and then select "Pipeline". Also, make sure as you configure your jobs, limit the number of old builds to 1 or 2 so your VM doesn't have memory issues. I usually limit days to 1 and builds to 1, and do not allow for concurrent builds.


8. If you're working with a private repo, you will need to configure jenkins with your gitlab credentials. To do this, navigate to Jenkins homepage and then to "Manage Jenkins" on the left side of the landing page, and then "Manage Credentials". Select your global domain under your stores, and then select "Add Credentials." From here, include your gitlab username and password. Once you click okay, an ID will be generated by Jenkins representing these credentials. This is your "credentialsId" in your Jenkinsfile.


9. Make sure to add your webhook to your GitLab repository. This must be done with the GitLab Plugin. To install it, navigate to "Manage Jenkins">"Manage Plugins" and find it under "Available."

- Once installed, a webhook must be created in your GitLab repository which is authenticated using a Jenkins API token.
- This is best done with another user (non-admin user with Read + Job/Build permissions)
  - user is created under "Manage Jenkins">"Manage Users"
  - permissions are set under "Manage Jenkins">"Configure Global Security" using Matrix-based security
    - add the user you created to the matrix
    - select Overall Read and Job Build
    - save changes
- Log in as your user and generate API key
  - click on the name of your user on the upper right-hand corner of jenkins, and select Configure
  - generate an API token
  - copy and paste this token, store it in a safe place
- Go to your GitLab repository and configure a webhook
  - navigate to the repo, then "Settings">"Webhooks"
  - the url should be formatted as http://[user id]:[api token]@[vm ip]:8080/project/[project name]
- the build trigger needs also to be enabled in the configuration of the jenkins job
  - because of the GitLab Plugin, there should now be a GitLab build trigger. Select this option
- another type of network traffic we need to allow to your VM? You know what that means https://docs.gitlab.com/ee/user/gitlab_com/#ip-range


--- Adding in additional secrets to jenkins ---

In order to add additional secure values to your jenkins build through jenkins, you can add "secret text" to your credential manager and then access those values within your Jenkinsfile. To do this, navigate to the credential manager (see 7), but instead of choosing username/password, select "secret text." This will allow you to securely store things like your db url, username, and password. In order to access these in your script, create an environment variable and assign it to credentials('credentialsId').



